unit hitcContWrite;

interface

uses Windows, KOL, Share, Debug, hxContPlug;

const
  tcOK = FT_SETSUCCESS;
  tcError = FT_FILEERROR;

type
  THitcContWrite = class(TDebug)
  private
    FFieldIndex, FUnitIndex, FResult: integer;
    FData: TData;
    FName: string;
    procedure SetValue(FieldIndex, UnitIndex, Flags: integer; FieldValue: PChar; out Result: integer);
  public
    _event_onLoadFile: THi_Event;
    _event_onSetValue: THi_Event;
    _event_onSaveFile: THi_Event;
    _event_onChangingEnd: THi_Event;
    
    _prop_Default: integer;
    
    constructor Create; reintroduce;
    procedure _work_doResult(var _Data: TData; Index: word);
    procedure _var_FileName(var _Data: TData; Index: word);
    procedure _var_FieldIndex(var _Data: TData; Index: word);
    procedure _var_UnitIndex(var _Data: TData; Index: word);
    procedure _var_FieldValue(var _data: TData; Index: word);
  end;
  
function ContentSetValue(FileName: PChar; FieldIndex, UnitIndex, FieldType: integer; FieldValue: PChar; Flags: integer): integer; stdcall;

exports
  ContentSetValue;

implementation

uses
  hiContPlug;

var
  Obj: THitcContWrite;

function ContentSetValue(FileName: PChar; FieldIndex, UnitIndex, FieldType: integer; FieldValue: PChar; Flags: integer): integer; stdcall;
begin
  with Obj do
    begin
      if Flags or SETFLAGS_FIRST_ATTRIBUTE = Flags then
        begin
          Fname := FileName;
          _hi_onEvent(_event_onLoadFile, FName);
        end;
      if FieldIndex <> -1 then
        SetValue(FieldIndex, UnitIndex, Flags, FieldValue, Result);
      if Flags or SETFLAGS_LAST_ATTRIBUTE = Flags then
        begin
          _hi_onEvent(_event_onSaveFile, FName);
          FFieldIndex := 0;
          FUnitIndex := 0;
          FName := '';
        end;
      if (FieldIndex = -1) and (FileName = nil) then
        begin
          _hi_onEvent(_event_onChangingEnd);
          Result := FT_SETSUCCESS;
        end;
    end;
end; { of function ContentSetValue
-----------------------------------------------------------}
  
constructor THitcContWrite.Create;
begin
  inherited;
  Obj := self;
  _InitFlags := CONTFLAGS_EDIT or CONTFLAGS_FIELDEDIT;
end;{ of constructor THitcContWrite.Create
-----------------------------------------------------------}

procedure THitcContWrite.SetValue;
begin
  case PField(_Plug.Fields.Items[FieldIndex]).fdFieldType of
    FT_NUMERIC_32, FT_BOOLEAN: dtInteger(FData, PInteger(FieldValue)^);
    FT_NUMERIC_FLOATING: dtReal(FData, PDouble(FieldValue)^);
    FT_STRING: dtString(FData, FieldValue);
    else dtNull(FData);
  end;  
  FResult := _prop_Default;
  FFieldIndex := FieldIndex;
  FUnitIndex := UnitIndex;
  _hi_OnEvent(_event_onSetValue, FieldIndex);
  Result := FResult;
end; { of procedure THitcContWrite.GetValue
-----------------------------------------------------------}

procedure THitcContWrite._work_doResult;
const
  r: array[false..true] of integer = (FT_FILEERROR, FT_SETSUCCESS);
begin
  FResult := r[ReadBool(_data)];
end; { of procedure THitcContWrite._work_doResult
-----------------------------------------------------------}

procedure THitcContWrite._var_FileName;
begin
  dtString(_Data, FName);
end; { of procedure THitcContWrite._var_FileName
-----------------------------------------------------------}

procedure THitcContWrite._var_FieldIndex;
begin
  dtInteger(_Data, FFieldIndex);
end; { of procedure THitcContWrite._var_FieldIndex
-----------------------------------------------------------}

procedure THitcContWrite._var_UnitIndex;
begin
  dtInteger(_Data, FUnitIndex);
end; { of procedure THitcContWrite._var_UnitIndex
-----------------------------------------------------------}

procedure THitcContWrite._var_FieldValue;
begin
  dtData(_Data, FData);
end; { of procedure THitcContWrite._var_FieldValue
-----------------------------------------------------------}

end.